package com.ruoyi.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.domain.vo.ReviewEnterpriseArchiveFileVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 审查细则的审查结果
 * @TableName t_review_details_result
 */
@ApiModel
@TableName(value ="t_review_details_result")
@Data
public class ReviewDetailsResult implements Serializable {
    /**
     * 主键
     */
    @ApiModelProperty("主键")
    @TableId(type = IdType.ASSIGN_ID)
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long id;

    /**
     * 审核是否通过（0未通过、1通过）
     */
    @ApiModelProperty("审核是否通过（0未通过、1通过）")
    private Integer passed;

    /**
     * 评论
     */
    @ApiModelProperty("评论")
    private String comment;

    /**
     * 厂商适用于该细则的场景截图或照片（多个url用","分隔）
     */
    @ApiModelProperty("厂商适用于该细则的场景截图或照片（多个url用\",\"分隔）")
    private String imagesUrl;

    /**
     * 关联到的细则id
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    @ApiModelProperty("关联到的细则id")
    private Long reviewDetailsId;

    /**
     * 关联的任务id
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    @ApiModelProperty("关联的任务id")
    private Long taskId;

    /**
     * 审核人id
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    @ApiModelProperty("审核人id")
    private Long userId;

    /**
     * 审核人姓名
     */
    @ApiModelProperty("审核人姓名")
    private String userName;

    /**
     * 最后修改时间
     */
    @ApiModelProperty("最后修改时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private Date lastModifyTime;

    @ApiModelProperty("文件目录")
    private String catalogue;

    @JsonFormat(shape = JsonFormat.Shape.STRING)
    @ApiModelProperty("关联到车企留档文件")
    private String reviewEnterpriseArchiveId;

    @ApiModelProperty("文件名称")
    private String fileName;

    @TableField(exist = false)
    @ApiModelProperty("文件列表")
    List<ReviewEnterpriseArchiveFileVO> fileList;


}
