package com.ruoyi.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 车企留档文件
 * @TableName t_review_enterprise_archive
 */
@TableName(value ="t_review_enterprise_archive")
@Data
public class ReviewEnterpriseArchive implements Serializable {

    @ApiModelProperty("主键")
    @TableId(type = IdType.ASSIGN_ID)
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long id;

    /**
     * 企业名称
     */
    @ApiModelProperty("企业名称")
    private String enterpriseName;

    /**
     * 文件名称
     */
    @ApiModelProperty("文件名称")
    private String fileName;

    /**
     * 文件版本
     */
    @ApiModelProperty("文件版本")
    private String version;

    /**
     * 发布日期
     */
    @ApiModelProperty("发布日期")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date publishDate;

    /**
     * 文件状态
     */
    @ApiModelProperty("文件状态")
    private String status;

    /**
     * 文件识别号
     */
    @ApiModelProperty("文件识别号")
    private String identifyNumber;

    /**
     * 存储位置
     */
    @ApiModelProperty("存储位置")
    private String storage;

    /**
     * 图片地址
     */
    @ApiModelProperty("图片地址")
    private String photo;

    /**
     * 关联到任务id
     */
    @ApiModelProperty("关联到任务id")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long taskId;

    @ApiModelProperty("创建人")
    private String createBy;

    @ApiModelProperty("创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm")
    private Date createTime;

}