package com.ruoyi.domain;

import java.util.Date;
import java.util.List;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.core.domain.BaseEntity;
import com.ruoyi.domain.vo.SampleTaskVo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 样品管理对象 t_sample_management
 * 
 * @author ruoyi
 * @date 2024-01-29
 */

@ApiModel
@TableName(value ="t_sample")
@Data
public class Sample extends BaseEntity
{
    private static final long serialVersionUID = 1L;
    // 整车样品
    public static final String SAMPLE_FLAG_CAR = "0";
    // 零部件样品

    public static final String SAMPLE_FLAG_PART = "1";
    /** 主键 */
    @ApiModelProperty("主键")
    @TableId(type = IdType.ASSIGN_ID)
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long id;

    /** 车辆识别码 */
    @ApiModelProperty("车辆识别码")
    private String identificationCode;

    /** 样品编号 */
    @ApiModelProperty("样品编号")
    private String sampleNumber;

    /** 样品名称 */
    @ApiModelProperty("样品名称")
    private String sampleName;

    /** 送样着 */
    @ApiModelProperty("送样着")
    private String sampleSender;

    /** 样品数量 */
    @ApiModelProperty("样品数量")
    private String numberOfSamples;

    /** 送样日期 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty("送样日期")
    private Date deliveryDate;

    /** 生产日期 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty("生产日期 ")
    private Date manufactureDate;

    /** 生产企业 */
    @ApiModelProperty("生产企业")
    private String manufacturingEnterprise;

    /** 0：整车样品  1：零部件样品 */
    @ApiModelProperty("0：整车样品  1：零部件样品")
    private String flag;

    /**  商标 */
    @ApiModelProperty("商标")
    private String trademark;

    /**  备注 */
    @ApiModelProperty("备注")
    private String remark;

    /**  样品照片 */
    @ApiModelProperty("样品照片")
    private String samplePhotos;

    /** 车企id */
    @ApiModelProperty("车企id")
    @JsonFormat(shape = JsonFormat.Shape.STRING)
    private Long manufacturingEnterpriseId;

    @ApiModelProperty("企业名称实时")
    private String enterpriseName;

    private List<SampleTaskVo>  taskSampleRelation;
}
