package com.ruoyi.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ruoyi.domain.CarReviewTask;
import com.ruoyi.domain.ReviewDetails;
import com.ruoyi.domain.ReviewKeyPoint;
import com.ruoyi.domain.SystemReviewTask;
import com.ruoyi.web.request.ReviewFindListRequest;
import com.ruoyi.web.response.ResultCountResponse;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface ReviewDetailsMapper extends BaseMapper<ReviewDetails> {
    List<ReviewDetails> findByKeyPointList(@Param("reviewKeyPointList") List<ReviewKeyPoint> reviewKeyPointList);

    /**
     * 根据任务id查询没有回答细则的数量
     * @param taskId
     * @return
     */
    List<ReviewDetails> findNoResult(@Param("taskId") Long taskId, @Param("type") String type);

    Double count (@Param("taskId")Long taskId, @Param("type")String type);

    List<ResultCountResponse> systemAnswerCount(@Param("systemReviewTaskList")List<SystemReviewTask> systemReviewTaskList, @Param("type")String type);

    List<ResultCountResponse> carAnswerCount(@Param("carReviewTaskList")List<CarReviewTask> carReviewTaskList, @Param("type")String type);

    // 根据要点id查询细则列表
    List<ReviewDetails> findByKeyPointId(@Param("keyPointId") Long keyPointId);

    // 查询细则列表
    List<ReviewDetails> findDetailsList(ReviewFindListRequest request);
}
