package com.ruoyi.mapper;

import com.ruoyi.domain.ReviewEnterpriseArchive;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ruoyi.domain.vo.ReviewEnterpriseArchiveViewItemVO;
import com.ruoyi.web.request.ReviewEnterpriseArchiveFindByTaskIdRequest;
import com.ruoyi.web.request.ReviewEnterpriseArchiveFindRequest;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
* @author wangfei
* @description 针对表【t_review_enterprise_archive(车企留档文件)】的数据库操作Mapper
* @createDate 2024-02-22 15:32:57
* @Entity com.ruoyi.domain.ReviewEnterpriseArchive
*/
@Repository
public interface ReviewEnterpriseArchiveMapper extends BaseMapper<ReviewEnterpriseArchive> {

    List<ReviewEnterpriseArchive> findByTaskId(@Param("taskId") Long taskId);

    // 剔除细则被删除而结果保留的数据
    List<ReviewEnterpriseArchiveViewItemVO> findViewItemVOByTaskId(@Param("taskId") Long taskId);

    Long findFileName(@Param("taskId") Long taskId,@Param("fileName") String fileName);

    List<ReviewEnterpriseArchive> findEnterpriseArchive(ReviewEnterpriseArchiveFindRequest request);

    ReviewEnterpriseArchive findByFileName(@Param("fileName") String fileName);

    List<ReviewEnterpriseArchive> findList(@Param("taskId") Long taskId);

    List<ReviewEnterpriseArchive> findEnterpriseArchiveByTaskId(ReviewEnterpriseArchiveFindByTaskIdRequest request);
}




