package com.ruoyi.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ruoyi.domain.Sample;
import com.ruoyi.domain.TaskSampleRelation;
import com.ruoyi.web.request.SampleManagementRequest;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;


@Repository
public interface SampleManagementMapper extends BaseMapper<Sample> {
    /**
     * 查询样品管理
     *
     * @param id 样品管理主键
     * @return 样品管理
     */
    public Sample selectSampleManagementById(Long id);

    /**
     * 查询样品管理列表
     *
     * @param sampleManagementRequest 样品管理
     * @return 样品管理集合
     */
    public List<Sample> selectSampleManagementList(SampleManagementRequest sampleManagementRequest);

    /**
     * 新增样品管理
     *
     * @param tSampleManagement 样品管理
     * @return 结果
     */
    public int insertSampleManagement(Sample tSampleManagement);

    /**
     * 修改样品管理
     *
     * @param tSampleManagement 样品管理
     * @return 结果
     */
    public int updateSampleManagement(Sample tSampleManagement);

    /**
     * 查询车辆识别码是否重复
     * */
    public int selectIdentificationCodeCount(Sample sampleManagement);

    /**
     * 查询样品编号是否重复
     * */
    public int selectSampleNumberCount(Sample sampleManagement);

    /**
     * 根据车辆识别码和样品编号查询样品信息
     * */
    public List<Sample> selectSampleList(SampleManagementRequest sampleManagementRequest);

    List<Sample> findByIdList(@Param("relationList") List<TaskSampleRelation> relationList,@Param("id") Long id);

}
