package com.ruoyi.mapper;

import com.ruoyi.domain.TestUseCase;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ruoyi.domain.vo.TestUsecaseVO;
import com.ruoyi.web.request.TestUserCaseRequest;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
* @author wangfei
* @description 针对表【t_test_usecase(测试用例)】的数据库操作Mapper
* @createDate 2024-02-18 13:41:28
* @Entity com.ruoyi.domain.TestUseCase
*/
@Repository
public interface TestUseCaseMapper extends BaseMapper<TestUseCase> {

    /**
     * 查询测试用例列表
     *
     * @param testUserCaseRequest 测试用例库
     * @return 测试用例集合
     */
    public List<TestUseCase> selectseCaseList(TestUserCaseRequest testUserCaseRequest);

    /**
     * 查询测试用例列表
     * @param id
     * @return
     */
    List<TestUsecaseVO> selectListByTaskId(Long id);
}




