package com.ruoyi.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.bean.BeanUtils;
import com.ruoyi.domain.Standard;
import com.ruoyi.mapper.StandardMapper;
import com.ruoyi.service.StandardService;
import com.ruoyi.web.request.StandardEditRequest;
import com.ruoyi.web.request.StandardGetInfoRequest;
import com.ruoyi.web.request.StandardListRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class StandardServiceImpl extends ServiceImpl<StandardMapper, Standard> implements StandardService {

    @Autowired
    private StandardMapper standardMapper;

    @Autowired
    private StandardService standardService;

    /**
     * 分页查询
     * @param
     * @return
     */
    @Override
    public List<Standard> findList(StandardListRequest request) {
        return standardMapper.findList(request);
    }

    /**
     * 根据id查询
     * @param id
     * @return
     */
    @Override
    public Standard findListById(Long id) {
        return standardMapper.findListById(id);
    }

    @Override
    public void editStandard(StandardEditRequest request) {

        Standard standard = new Standard();
        BeanUtils.copyBeanProp(standard, request);
        standardService.updateById(standard);
    }

    @Override
    public Standard getInfo(StandardGetInfoRequest request) {
        return standardMapper.selectById(request.getId());
    }
}
