package com.ruoyi.service.impl;

import com.ruoyi.common.constant.HttpStatus;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.domain.Task;
import com.ruoyi.service.TaskState;
import com.ruoyi.web.request.TaskStartRequest;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Transactional
@Service
public class TaskStateFinish extends TaskStateAdapter implements TaskState, InitializingBean {

    @Autowired
    private TaskStateContext taskStateContext;

    @Autowired
    private ApplicationContext applicationContext;

    @Override
    public void doCreate(Task task, List<String> taskList) {
        throw new ServiceException("不能创建一个已经结束的任务", HttpStatus.ERROR);
    }

    @Override
    public void doStart(Task task, TaskStartRequest request) {
        throw new ServiceException("不能开始一个已经结束的任务", HttpStatus.ERROR);
    }

    @Override
    public void doSubmit(Task task) {
        throw new ServiceException("不能完成一个已经结束的任务", HttpStatus.ERROR);
    }

    @Override
    public void afterPropertiesSet() throws Exception {
        taskStateContext.putResource(Task.TASK_STATUS_FINISH, applicationContext.getBean(this.getClass()));
    }
}
