package com.ruoyi.service.impl;

import com.ruoyi.common.constant.HttpStatus;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.domain.CarReviewTask;
import com.ruoyi.domain.SystemReviewTask;
import com.ruoyi.domain.Task;
import com.ruoyi.mapper.CarReviewTaskMapper;
import com.ruoyi.mapper.ReviewDetailsMapper;

import com.ruoyi.mapper.SystemReviewTaskMapper;
import com.ruoyi.service.TaskService;
import com.ruoyi.service.TaskState;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;
import java.util.Objects;

@Transactional
@Service
public class TaskStatePending extends TaskStateAdapter implements TaskState, InitializingBean {

    @Autowired
    private TaskStateContext taskStateContext;

    @Autowired
    private ReviewDetailsMapper reviewDetailsMapper;

    @Autowired
    private TaskService taskService;

    @Autowired
    private ApplicationContext applicationContext;

    @Autowired
    private SystemReviewTaskMapper systemReviewTaskMapper;

    @Autowired
    private CarReviewTaskMapper carReviewTaskMapper;



    @Override
    public void doCreate(Task task, List<String> taskList) {
        throw new ServiceException("不能创建一个已经开始的任务", HttpStatus.ERROR);
    }

    @Override
    public void doSubmit(Task task) {

        if (task.getPointer() < task.getMaxPointer()) {
            task.setTaskStatus(Task.TASK_STATUS_PENDING);
            task.setRunStatus(Task.RUN_STATUS_RUNNABLE);
        } else {
            task.setTaskStatus(Task.TASK_STATUS_FINISH);
            task.setTaskEndTime(new Date());
            task.setRunStatus(Task.RUN_STATUS_STATUS_RUNNING);
        }

        taskService.updateById(task);
    }

    @Override
    public void afterPropertiesSet() throws Exception {
        taskStateContext.putResource(Task.TASK_STATUS_PENDING, applicationContext.getBean(this.getClass()));
    }
}
