package com.ruoyi.service.impl;

import com.alibaba.fastjson2.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.domain.TestRecords;
import com.ruoyi.mapper.TestRecordsMapper;
import com.ruoyi.service.TestRecordsService;
import okhttp3.Request;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.util.EntityUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.nio.charset.Charset;
import java.util.HashMap;
import java.util.Map;


@Transactional
@Service
public class TestRecordsServiceImpl extends ServiceImpl<TestRecordsMapper, TestRecords> implements TestRecordsService {


    public void getValue() throws IOException {
        JSONObject jsonObject = getInverseParamByUrl("http://10.12.48.78:8090/DescribeProjectTestResult");
    }

    public static JSONObject getInverseParamByUrl(String apiUrl) throws IOException {
        // 调用请求
        URL url = new URL(apiUrl);
        HttpURLConnection connection = (HttpURLConnection) url.openConnection();
        connection.setRequestMethod("GET");

        BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream()));
        StringBuilder response = new StringBuilder();
        String line;
        while ((line = reader.readLine()) != null) {
            response.append(line);
        }
        reader.close();
        // 解析成JSON对象
        String jsonResponseString = response.toString();
        JSONObject jsonObject = JSONObject.parseObject(jsonResponseString);
        return jsonObject;
    }

    public static String doPost(String url, JSONObject json){
        try {
            CloseableHttpClient httpClient = HttpClientBuilder.create().build();
            HttpPost post = new HttpPost(url);

            // 首先Header部分需要设定字符集为：uft-8
            post.addHeader("Content-Type", "application/json;charset=utf-8");
            // 此处也需要设定
            post.setHeader("Accept", "*/*");
            post.setHeader("Accept-Encoding", "gzip, deflate, br");
            post.setHeader("Connection", "keep-alive");
//            post.setHeader("User-Agent", "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3904.97 Safari/537.36");
            post.setEntity(new StringEntity(json.toString(), Charset.forName("UTF-8"))); //设置请求参数
            HttpResponse response = httpClient.execute(post);
            int statusCode = response.getStatusLine().getStatusCode();
            if (HttpStatus.SC_OK == statusCode){
                //返回String
                String res = EntityUtils.toString(response.getEntity());
                System.out.println(res);
                return res;
            }else{
                return "调用POST请求失败";
            }

        } catch (Exception e) {
            e.printStackTrace();
            return "调用POST请求失败";
        }
    }

//    public static void main(String[] args) {
//        Map<String, Object> map = new HashMap<>();
//        map.put("id", "project_items;1");
//        map.put("verbose", "ALL");
//        JSONObject json = new JSONObject(map);
//
//        //以post形式请求接口
//        String result = doPost("http://10.12.48.78:8090/DescribeProjectTestResult", json);
//        JSONObject jsonObject = JSONObject.parseObject(result);
//        String data = jsonObject.get("data").toString();
//
//        System.out.println("data = " + data);
//    }


//    public static void main(String[] args) {
//
//        try {
//            String apiUrl = "http://10.12.48.78:8090/DescribeProjectTestResult"; // 第三方URL
//
//
//            URL url = new URL(apiUrl);
//            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
//            conn.setRequestMethod("POST");
//            conn.setDoInput(true);
//            conn.setDoOutput(true);
//
//            // 参数设置 ||
//            conn.setRequestProperty("Content-Type","application/json");
//            conn.connect();
//
//            // 设置请求体
//            OutputStreamWriter writer = new OutputStreamWriter(conn.getOutputStream(),"UTF-8");
//            JSONObject parm = new JSONObject();
//            parm.put("id","project_items;1");
//            parm.put("verbose","ALL");
//            writer.write(URLEncoder.encode(parm.toString(),"UTF-8"));
//            writer.flush();
//
//
//            int responseCode = conn.getResponseCode();
//            if (responseCode == HttpURLConnection.HTTP_OK) {
//                BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream(),"UTF-8"));
//                String inputLine;
//                StringBuilder response = new StringBuilder();
////                StringBuffer response = new StringBuffer();
//
//                while ((inputLine = in.readLine()) != null) {
//                    response.append(inputLine);
//                }
//                in.close();
//                conn.disconnect();
//
//                String result = response.toString();
//                System.out.println("result = " + result);
//
////                String responseBody = response.toString();
////                JSONObject jsonObject = JSONObject.parseObject(responseBody);
////                System.out.println("Response body: " + responseBody);
////                System.out.println("jsonObject = " + jsonObject);
//            } else {
//                System.out.println("Request failed. Response code: " + responseCode);
//            }
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
//    }

}


