package com.ruoyi.web.response;

import com.ruoyi.domain.*;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.ArrayList;
import java.util.List;

@ApiModel(value = "CarReviewTaskViewResponse", description = "查询车辆审查任务详情响应体")
@Data
public class CarReviewTaskViewResponse {

    /**
     * 任务信息
     */
    @ApiModelProperty("任务信息")
    private CarReviewTask carReviewTask;

    /**
     * 任务开始后的场景变更信息
     */
    @ApiModelProperty("任务开始后的场景变更信息")
    private List<ReviewSceneChangeTask> reviewSceneChangeTasks;

    /**
     *
     * @return
     */
    @ApiModelProperty("细则列表")
    public List<ReviewDetails> getDetailsList() {

        List<ReviewDetails> detailsList = new ArrayList();

        for(ReviewStandard standard : carReviewTask.getStandard()) {
            for(ReviewKeyPoint keyPoint : standard.getKeyPointList()) {
                for(ReviewDetails details : keyPoint.getReviewDetailsList()) {
                    detailsList.add(details);
                }
            }
        }

        return detailsList;
    }



    @ApiModelProperty("测试场景")
    private List<TestScenario> testScenarioList;
}
